      subroutine mapskk(imom,x,q,m,wdth,sqsl,sqsu,s,sqs,ds)
c----------------------------------------------------------------------c
c Performs mappings of the s-channel propagators
c
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c 30 Jan., 2008; modified
c----------------------------------------------------------------------c

      implicit none
 
      integer, parameter :: dp=kind(1.d0)
      integer :: imom
      real(dp) :: x,q(0:3),m,wdth,sqsl,sqsu,s,sqs,ds
      real(dp) :: wdm,ats,nfct,rs

      if (imom == 1) then
       if (wdth > 0.d0) then
        wdm=wdth*m
        ats=-atan((m-sqsl)*(m+sqsl)/wdm)
        nfct=wdm/(atan((sqsu-m)*(sqsu+m)/wdm)-ats)
        s=wdm*tan(wdm/nfct*x+ats)+m*m
        sqs=sqrt(s)
        ds=(((sqs-m)*(sqs+m))**2+wdm*wdm)/nfct
       else
        if (m > 0.d0 .or. sqsl == 0.d0) then 
         ds=(sqsu-sqsl)*(sqsu+sqsl)
         s=ds*x+sqsl*sqsl
         sqs=sqrt(s)
        else
         rs=sqsu/sqsl
         s=sqsl*sqsl*rs**(2.d0*x)
         sqs=sqrt(s)
         ds=2.d0*log(rs)*s
        end if
       end if
      else
       s=(q(0)-q(3))*(q(0)+q(3))-q(1)*q(1)-q(2)*q(2)
       sqs=sqrt(s)
       if (wdth > 0.d0) then
        wdm=wdth*m
        ats=-atan((m-sqsl)*(m+sqsl)/wdm)
        nfct=wdm/(atan((sqsu-m)*(sqsu+m)/wdm)-ats)
        ds=(((sqs-m)*(sqs+m))**2+wdm*wdm)/nfct
       else
        if (m > 0.d0 .or. sqsl == 0.d0) then 
         ds=(sqsu-sqsl)*(sqsu+sqsl)
        else
         ds=2.d0*log(sqsu/sqsl)*s
        end if
       end if
      end if

      end

