      program carlomat
c----------------------------------------------------------------------c
c Automized calculation of the cross section of SM process
c
c                 f_1 f_2 -> f_3 f_4 ... f_next
c
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c 9 February, 2006; modified 
c----------------------------------------------------------------------c

      use mytypes
      use extpart

      implicit none

      character(80) :: process

c Specify a process below. The maximum number of external particles 
c is 12. 
c Standard Model particles include (notation adopted from MadGraph)
c     Quarks:   d u s c b t d~ u~ s~ c~ b~ t~
c     Leptons:  e- mu- ta- e+ mu+ ta+ ve vm vt ve~ vm~ vt~
c     Bosons:   g a z w+ w- h
c Other particles:
c     Nucleons: p, p~, n, n~
c     Mesons: pi-, pi+, pi0, k-, k+, k0, k0~, rho-, rho+, rho0, ome, phi,
c             rho1, rho2

      process='e+ e- -> pi+ pi- pi0 a'
 
c Take into account photon radiation from the initial state only (isr=1)/
c final state only (isr=2)/ both (isr=else)? Relevant only for processes with
c external photons.

      isr=1

c Short name of the process:

      prcsnm='auto'  ! If prcsnm='auto' then it is made automatically.

c Monte Carlo summing over polarizations: imcs=1 (yes)/else (no)?

      imcs=1

c Take into account the Cabibbo-Kobayashi-Maskawa mixing: ickm=1(yes)/else(no)?

      ickm=0

c Include the anomalous Wtb coupling: iwtb=1 (Yes)/else (No)? 
c (see K. Kolodziej, Phys. Lett. B584 (2004) 89)

      iwtb=0

      call readpart(process)

      call genmat

      end

