      subroutine mixpl(i1,k)
c----------------------------------------------------------------------c
c Mixes particle i1 with other particles
c
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c 25 March, 2014; Modified on 
c 5 March, 2015 - Weight and complex phase factors (s-dependent) 
c implemented
c 20 March, 2015 - Call to bbkk changed
c----------------------------------------------------------------------c

      use extpart
      use intpart
      use vertices

      implicit none

      integer :: i1,k,k0,
     &           f1j,f1i,f1o,f1g,f1f,f1ct,f1n,f1e,
     &           i,j1,j2,oif1,blad1,blad2,di1,
     &           plj,pli,plo,plg,plf,plct,pln,ple
      integer, allocatable :: f1ix(:),plix(:)
      character(80) ind1,ind2,cn1,cn2,cl,clx
      character(2) cp1
      character(160) cl1,cl2

      open(16,file='partcls.tmp',access='direct',form='formatted',
     &                                                     recl=80)
      open(22,file='mdclsb.txt',
     &        access='direct',form='formatted',recl=160)

      read(16,'(i8,5(i3),i24,i3)',rec=i1) f1j,f1i,f1o,f1g,f1f,f1ct,f1n,
     &                                                             f1e
      allocate(f1ix(f1e),stat=blad2)
      read(20,'(26(i3))',rec=i1) f1ix

      k0=k
      pl(i1)%mx=1
      pl(i1)%dm=0

      do i=1,nbba
       oif1=f1o*f1i*f1j
       do j1=1,2
        if (oif1 == mcbb(i,j1)) then
         do j2=1,2
          if (j1 /= j2) then
           k=k+1
           pl(k)%mx=2
           pl(k)%k=pl(i1)%k
           plj=abs(mcbb(i,j2))
           plo=-1                  ! an internal boson is always incoming 
                                   ! to the vertex
           pli=mcbb(i,j2)/(plo*plj)
           call conveyfg(plj,plg,plf)
           if (plf < 0) then
            plo=-plo          ! therefore a charged boson should be 
                              ! considered as 
                              ! the outgoing particle from the other vertex
           end if
           plct=clbb(i,j2)
           pln=f1n
           ple=f1e
           call convert
           allocate (plix(ple),stat=blad2)
           plix=f1ix
           write(ind1,'(i16)') i1
           write(ind2,'(i16)') k
           write(cn1,'(i16)') f1n
           write(cn2,'(i16)') pln

           if (i1 > nexpl) then
            cp1='-p'
           else
            if (f1o < 0) then
             cp1='p'
            else
             cp1='-p'
            end if
           end if

c           cl1='      call bbkk('
c           cl2='      call bbmd('//trim(gbb(i))//','
c     &                           //trim(cp1)//trim(adjustl(ind1))//','
           cl1='      call bbkk(i'//trim(wdbb(i,j2))//
     &                        ',i'//trim(msbb(i,j2))//
     &    ',w'//trim(msbb(i,j2))//',d'//trim(msbb(i,j2))//','
           cl2='      call bbmd(i'//trim(msbb(i,j2))//
     &    ',w'//trim(msbb(i,j2))//',d'//trim(msbb(i,j2))//
     &    ','//trim(msbb(i,j2))//','//trim(gbb(i))//','
     &                           //trim(cp1)//trim(adjustl(ind1))//','
           cl='u'//trim(adjustl(ind2))//'(0:3,'//
     &                                        trim(adjustl(cn2))//')'
           write(21,'(a)',rec=k) cl

           write(18,'(a)',rec=k) trim(cl1)//
     &          'u'//trim(adjustl(ind1))//','//trim(adjustl(cn1))//','
     &          //trim(cp1)//trim(adjustl(ind1))//
     &         ',u'//trim(adjustl(ind2))//','//trim(adjustl(cn2))//','
     &          //'p'//trim(adjustl(ind2))//','//trim(gbb(i))//','
     &          //trim(msbb(i,j2))//','//trim(wdbb(i,j2))//')'
           write(31,'(a10,a10)',rec=k) trim(mffb(i,j2)),trim(wffb(i,j2))
           if (imcs == 1) then
            write(22,'(a)',rec=k) trim(cl2)
     &              //'u'//trim(adjustl(ind1))//','
           else
            write(22,'(a)',rec=k) trim(cl2)//'u'//trim(adjustl(ind1))
     &                            //'(:,h'//trim(adjustl(ind1))//'(h)),'
           end if
           write(20,'(26(i3))',rec=k) plix
           read(13,'(a)',rec=i1) clx   ! copy color info of particle i1
           write(13,'(a)',rec=k) clx   ! to particle k

           di1=size(pl(i1)%ip)
           allocate(pl(k)%ip(di1+1),stat=blad1)
           pl(k)%ip(:di1)=pl(i1)%ip
           pl(k)%ip(di1+1)=i1
          end if
         end do
        end if
       end do
      end do

      deallocate(f1ix,plix,stat=blad2)

      close(16)
      close(22)

      pl(i1)%dm=k-k0

      allocate (pl(i1)%im(pl(i1)%dm),stat=blad2)

      if (pl(i1)%dm > 0) then
       do i=1,pl(i1)%dm
        pl(i1)%im(i)=k0+i
       end do
      end if

      contains

       subroutine convert

       pl(k)%ct=plct

       write(16,'(i8,5(i3),i24,i3)',rec=k) plj,pli,plo,plg,plf,plct,pln,
     &                                                              ple

       end subroutine convert

      end subroutine mixpl
